#include <iostream>
#include "brownian2d.h"
using namespace std;

int main(int argc, char* argv[]) {

  system("date");  

  if(argc == 1) {
    cout << "Please enter the version of algorithm to use: 2a or 2b or 3\n";
    exit(EXIT_FAILURE);
  }

  string algo = argv[1];

  if(algo == "2a") {
    cout << "Algorithm 2a: randomly select a neighbour's spin.\n"
	 << "4-cases modified Metropolis acceptance ratios.\n";
    brownian2d simulation;
    simulation.minimize(argv[1]);
  }
  else if(algo == "2b") {
    cout << "Algorithm 2b: randomly select a neighbour's spin.\n"
	 << "4-cases Metropolis acceptance ratios.\n";
    algorithm2b simulation;
    simulation.minimize(argv[1]);
  }
  else if(algo == "3") {
    cout << "Algorithm 3: randomly select a neighbour's spin.\n"
	 << "2-cases Metropolis acceptance ratios.\n";
    algorithm3 simulation;
    simulation.minimize(argv[1]);
  }
  else {
    cout << "Please enter a valid version of algorithm: 2a or 2b or 3\n";
    exit(EXIT_FAILURE);
  }
  system("date");

}
