#ifndef BUBBLE_H
#define BUBBLE_H
#include <iostream>

class bubble {
 private:
  int spin;
  int type;                    // 0 = medium(background) 1 = bubble
  int area;
  int target_area;
  int sum_x, sum_y;            // ctr_x = sum_x/area, ctr_y = sum_y/area
  int energy;
  float initial_ctr_x, initial_ctr_y;
  friend class simple_lattice_point;

 public:
  bubble(int sp = 0, int ty = 0, int ta = 0) : 
    spin(sp), type(ty), target_area(ta), area(0), energy(0) {}
  ~bubble() {}

  void set_spin(int sp) { spin = sp; }
  void set_type(int ty) { type = ty; }
  void set_area(int a) { area = a; }
  void increase_area(const int& a=1) { area += a; }
  void decrease_area(const int& a=1) { area -= a; }
  void set_target_area(int ta) { target_area = ta; }
  void set_sum_xy(int x, int y) { sum_x = x; sum_y = y; }
  void update_sum_xy(const int& x, const int& y) { sum_x += x; sum_y += y; }
  void set_initial_ctr() { initial_ctr_x = float(sum_x)/area; 
                           initial_ctr_y = float(sum_y)/area; }
  void set_energy(int e) { energy = e; }
  void increment_energy(int de) { energy += de; }

  int get_spin() const { return spin; }
  int get_type() const { return type; }
  int get_area() const { return area; }
  int get_target_area() const { return target_area; }
  int get_energy() const { return energy; }
  float get_ctr_x() const { return float(sum_x)/area; }
  float get_ctr_y() const { return float(sum_y)/area; }
  float get_initial_ctr_x() const { return initial_ctr_x; }
  float get_initial_ctr_y() const { return initial_ctr_y; }
  float get_rsquare() const { 
    float x = get_ctr_x(); 
    float y = get_ctr_y();
    return ((x - initial_ctr_x)*(x - initial_ctr_x) +
	    (y - initial_ctr_y)*(y - initial_ctr_y));
  }
};

#endif
