% pic.dat constains a 1-d array of integers
% The first element of pic.dat i.e. pic(1), is the monte carlo step
% reshape(pic, dim, dim) reshapes the 1-d array to a dim x dim array
% matlab starts index at 1, the colormap converts 1 to RGB[1 1 1], white;
% 2 to RGB[1 0 0], red; 3 to RGB[0 1 0], green; and 4 to RGB[0 0 1] blue
% Since pic contains 0 and it won't be rendered by the colormap,
% add 1 to every element

%clear all

function output = visualize1(filename, mcs, x_dim, y_dim)
fid   = fopen(filename, 'r');
frame = fscanf(fid, '%d');
frame = frame + 1;
mcs   = strread(mcs);     % Converting string to integer
x_dim = strread(x_dim);
y_dim = strread(y_dim);
A = reshape(frame, x_dim, y_dim);
cmap = [1 1 1; 1 0 0; 0 1 0; 0 0 1; 1 .8 0; 0 0 0];
output = image(A);
colormap(cmap);
axis image;
title(mcs);
%filename = sprintf('./movies/frame%d.tiff', mcs);
%imwrite(A, cmap, filename, 'tiff');
%I = imread(filename, 'tiff');
%imshow(I);

