(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     11860,        275]*)
(*NotebookOutlinePosition[     12836,        305]*)
(*  CellTagsIndexPosition[     12792,        301]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    \(\(FF[r_, x_] := 
        If[r\^2 - x\^2 \[LessEqual] 0, 0, \@\(r\^2 - x\^2\)];\)\), "\n", 
    \(\(GG[r_, x_, y_] := 
        If[FF[r, x] \[GreaterEqual] y, y, FF[r, x]];\)\), "\n", 
    \(\(HH[r_, x1_, x2_, y1_, y2_] := 
        NIntegrate[GG[r, x, y2], {x, x1, x2}] - 
          NIntegrate[GG[r, x, y1], {x, x1, x2}];\)\), "\n", 
    \(\(II[r_, x_, y_] := HH[r, x - 1, x, y - 1, y];\)\), "\n", 
    \(\(JJ[r_, x_, y_] := 
        If[II[r, x, y] \[GreaterEqual] 0.5, y, y - 1];\)\), "\n", 
    \(\(KK[r_, x_, top_] := 
        FixedPoint[JJ[r, x, #1] &, top];\)\[IndentingNewLine]\), "\n", 
    \(\(LL[r_] := 
        Module[{top = r}, \[IndentingNewLine]\t\t\tDo[
            top = \(M\[LeftDoubleBracket]x\[RightDoubleBracket] = 
                KK[r, x, top]\); \[IndentingNewLine]\t\t\t\ \ \ \ \ If[
              x \[GreaterEqual] top, 
              Break[]], \[IndentingNewLine]\t\t\t\ \ \ {x, 1, 
              r}]\[IndentingNewLine]\t\t\t];\)\[IndentingNewLine]\), "\n", 
    \(\(MyCircle[r_] := 
        Module[{hh = 0, top, A}, \[IndentingNewLine]\t\t\tM = 
            Table[0, {r}]; \[IndentingNewLine]\t\t\tLL[
            r]; \[IndentingNewLine]\t\t\tA = 
            Reverse[Union[M]]; \[IndentingNewLine]\t\t\tDo[
            top = A\[LeftDoubleBracket]y\[RightDoubleBracket]; \
\[IndentingNewLine]\t\t\t\ \ \ \ \ If[
              M\[LeftDoubleBracket]top\[RightDoubleBracket] =!= 0, 
              Break[]]; \[IndentingNewLine]\t\t\t\ \ \ \ \ hh += 
              Count[M, 
                A\[LeftDoubleBracket]y\[RightDoubleBracket]]; \
\[IndentingNewLine]\t\t\t\ \ \ \ \ M\[LeftDoubleBracket]top\
\[RightDoubleBracket] = hh, \[IndentingNewLine]\t\t\t\ \ \ \ \ {y, 1, 
              Length[A]}]; \[IndentingNewLine]\t\t\tExport["\<circle\>" <> 
              ToString[r] <> "\<.dat\>", 
            M, "\<List\>"];\[IndentingNewLine]\t\t\t\
];\)\[IndentingNewLine]\), "\n", 
    \(\(NN1 = {{1, 0}, {\(-1\), 0}, {0, 1}, {0, \(-1\)}};\)\), "\n", 
    \(\(NN2 = {{1, 1}, {\(-1\), 
            1}, {1, \(-1\)}, {\(-1\), \(-1\)}};\)\), "\n", 
    \(\(NN3 = {{2, 0}, {\(-2\), 0}, {0, 2}, {0, \(-2\)}};\)\), "\n", 
    \(\(NN4 = {{2, 1}, {\(-2\), 1}, {1, 2}, {\(-1\), 
            
            2}, {2, \(-1\)}, {\(-2\), \(-1\)}, {1, \(-2\)}, {\(-1\), \
\(-2\)}};\)\), "\n", 
    \(\(NN1to4 = 
        Join[{NN1}, {NN2}, {NN3}, {NN4}];\)\[IndentingNewLine]\), "\n", 
    \(IsBoundaryPixel[r_, x_, xn_, yn_] := \[IndentingNewLine]\t
      If[xn > r, 1, 
        xn2 = If[xn \[LessEqual] 0, Abs[xn] + 1, 
            xn]; \[IndentingNewLine]\t\t\t\thh = 
          M[\([x]\)] + yn; \[IndentingNewLine]\t\t\t\thh = 
          If[hh \[LessEqual] 0, Abs[hh] + 1, 
            hh]; \[IndentingNewLine]\t\t\t\tIf[xn2 > r, 1, 
          If[hh > M[\([xn2]\)], 1, 0]]]\[IndentingNewLine]\), "\n", 
    \(\(BoundaryPixelList[
          n_] := \[IndentingNewLine]Module[{xn, yn, r = Length[M], 
            BPL}, \[IndentingNewLine]\t\tBPL = 
            Table[0, {r}]; \[IndentingNewLine]\t\tDo[
            Do[Catch[
                Do[xn = 
                    x + NN1to4[\([n, i, 
                          1]\)]; \[IndentingNewLine]\t\t\t\t\tyn = \(-y\) + 
                      NN1to4[\([n, i, 2]\)]; \[IndentingNewLine]\t\t\t\t\tIf[
                    IsBoundaryPixel[r, x, xn, yn] \[Equal] 1, 
                    Throw[\(BPL[\([x]\)]++\)]], \[IndentingNewLine]\t\t\t\t\t\
{i, 1, Length[
                      NN1to4[\([n]\)]]}]; \[IndentingNewLine]\t\t\t\t\t\
Break[]], \[IndentingNewLine]\t\t\t{y, 0, 
                M[\([x]\)] - 1}], \[IndentingNewLine]\t\t\ \ \ \ {x, 1, 
              r}]; \[IndentingNewLine]\t\tReturn[
            BPL]\[IndentingNewLine]\t];\)\[IndentingNewLine]\), "\
\[IndentingNewLine]", 
    \(\(ConstantJij\  = \ {1, 1, 1, 1};\)\), "\[IndentingNewLine]", 
    \(\(AttenuatedJij\  = \ {1, 1/Sqrt[2], 1/2, 
          1/Sqrt[5]};\)\[IndentingNewLine]\), "\n", 
    \(\(PixelEnergy[r_, x_, y_, e_] := 
        Module[{xn, yn, 
            energy = 0}, \[IndentingNewLine]\t\t\t\t\t\t\t\t\ \ \ \ For[
            j = 1, j \[LessEqual] 
              e, \(j++\), \[IndentingNewLine]\t\t\t\t\t\t\t\t\tFor[i = 1, 
              i \[LessEqual] 
                Length[NN1to4[\([j]\)]], \(i++\), \[IndentingNewLine]\t\t\t\t\
\t\t\t\t\t\ \ \ \ \ xn = 
                x + NN1to4[\([j, i, 
                      1]\)]; \[IndentingNewLine]\t\t\t\t\t\t\t\t\t\ \ \ \ \ \
yn = \(-y\) + NN1to4[\([j, i, 
                      2]\)]; \[IndentingNewLine]\t\t\t\t\t\t\t\t\t\ \ \ \ \ \
energy += 
                ConstantJij[\([j]\)]*\[IndentingNewLine]\t\t\t\t\t\t\t\t\t\t\t\
IsBoundaryPixel[r, x, xn, 
                    yn]\[IndentingNewLine]\t\t\t\t\t\t\t\t\t\ \ \ \ \ ]\
\[IndentingNewLine]\t\t\t\t\t\t\t\t\t]; \[IndentingNewLine]\t\t\t\t\t\t\t\t\ \
\ \ \ \ \ \ Return[
            energy]\[IndentingNewLine]\t\t\t\t\t\t\t\t];\)\[IndentingNewLine]\
\), "\n", 
    \(\(BoundaryEnergyList[n_, e_] := 
        Module[{r = Length[M], BPL, 
            BEL}, \[IndentingNewLine]\t\t\t\t\t\t\t\tBPL = 
            BoundaryPixelList[n]; \[IndentingNewLine]\t\t\t\t\t\t\t\tBEL = 
            Table[0, {r}]; \[IndentingNewLine]\t\t\t\t\t\t\t\tDo[
            Do[BEL[\([x]\)] += 
                PixelEnergy[r, x, y, 
                  e], \[IndentingNewLine]\t\t\t\t\t\t\t\t\t{y, 0, 
                BPL[\([x]\)] - 
                  1}], \[IndentingNewLine]\t\t\t\t\t\t\t\t\ \ \ \ \ {x, 1, 
              r}]; \[IndentingNewLine]\t\t\t\t\t\t\t\tReturn[
            BEL]\[IndentingNewLine]\t\t\t\t\t\t\t\t];\)\[IndentingNewLine]\), \
"\n", 
    \(\(Perimeter[n_] := 
        4*Apply[Plus, BoundaryPixelList[n]];\)\[IndentingNewLine]\), "\n", 
    \(\(PerimeterEnergy[n_, e_] := 
        4*Apply[Plus, 
            BoundaryEnergyList[n, e]];\)\[IndentingNewLine]\), "\n", 
    \(\(Area := 4*Apply[Plus, M];\)\[IndentingNewLine]\), "\n", 
    \(EnergyLevelOccupancies[n_, e_] := \[IndentingNewLine]\t
      Module[{r = Length[M], BPL, ELO, 
          erange = 1}, \[IndentingNewLine]\t\t\tBPL\  = \ 
          BoundaryPixelList[n]; \[IndentingNewLine]\t\t\tDo[
          erange += Length[NN1to4[\([i]\)]], {i, 1, 
            e}]; \[IndentingNewLine]\t\t\tELO = 
          Table[0, {erange}]; \[IndentingNewLine]\t\t\tDo[
          Do[\(ELO[\([PixelEnergy[r, x, y, e] + 
                    1]\)]++\), \[IndentingNewLine]\t\t\t\t{y, 0, 
              BPL[\([x]\)] - 1}], \[IndentingNewLine]\t\t\t{x, 1, 
            r}]; \[IndentingNewLine]\t\t\tELO = 
          4*ELO; \[IndentingNewLine]\t\t\tELO[\([1]\)] = 
          Area - Apply[Plus, ELO]; \[IndentingNewLine]\t\t\tReturn[
          ELO]\t\[IndentingNewLine]\t\t]\)}], "Input"],

Cell[BoxData[
    \(AttJijList\  := \ 
      Module[{r = 3, \ i = 1, \ j = 1, \ NERange = 11, \ 
          A}, \[IndentingNewLine]\t\t\t\t\tA\  = \ 
          Table[0, {29}, {NERange}]; \[IndentingNewLine]\t\t\t\t\tWhile[
            r \[LessEqual] 64, \[IndentingNewLine]\t\t\t\t\t\tMyCircle[
              r]; \[IndentingNewLine]\t\t\t\t\t\tA[\([i, 1]\)] = 
              r; \[IndentingNewLine]\t\t\t\t\t\tj = 
              2; \[IndentingNewLine]\t\t\t\t\t\tFor[n = 1, 
                n \[LessEqual] 
                  4, \(n++\), \[IndentingNewLine]\t\t\t\t\t\t\tFor[e = n, 
                  e \[LessEqual] 
                    4, \(e++\), \[IndentingNewLine]\t\t\t\t\t\t\t\tA[\([i, 
                        j]\)] = 
                    N[PerimeterEnergy[n, 
                        e]]; \[IndentingNewLine]\t\t\t\t\t\t\t\t\(j++\)\
\[IndentingNewLine]\t\t\t\t\t\t\t\t]\[IndentingNewLine]\t\t\t\t\t\t\t]\
\[IndentingNewLine]\t\t\t\t\t\t\(i++\); \[IndentingNewLine]\t\t\t\t\t\tIf[
              r < 20, \(r++\), 
              r += 4]\[IndentingNewLine]\t\t\t\t\t\t]\[IndentingNewLine]\t\t\t\
\t\tExport["\<AttJijList.dat\>", 
            A, "\<Table\>"];\[IndentingNewLine]\t\t\t\t\t]\)], "Input"],

Cell[BoxData[
    \(AttJijList\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(EnergyLevelOccupancies[2, 2]\)], "Input"],

Cell[BoxData[
    \({1616, 56, 24, 76, 32, 0, 0, 0, 0}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(NE[n_, e_] := 
      Module[{r = 3, i = 1, j, erange = 2, 
          A}, \[IndentingNewLine]\t\t\t\t\tDo[
          erange += Length[NN1to4[\([i]\)]], {i, 1, 
            e}]; \[IndentingNewLine]\t\t\t\t\tA = 
          Table[0, {29}, {erange}]; \[IndentingNewLine]\t\t\t\t\tWhile[
            r \[LessEqual] 64, \[IndentingNewLine]\t\t\t\t\t\tMyCircle[
              r]; \[IndentingNewLine]\t\t\t\t\t\tA[\([i, 1]\)] = 
              r; \[IndentingNewLine]\t\t\t\t\t\tA[\([i, 
                  Range[2, erange]]\)] = 
              EnergyLevelOccupancies[n, 
                e]; \[IndentingNewLine]\t\t\t\t\t\t\(i++\); \
\[IndentingNewLine]\t\t\t\t\t\tIf[r < 20, \(r++\), 
              r += 4]\[IndentingNewLine]\t\t\t\t\t\t]\[IndentingNewLine]\t\t\t\
\t\tExport["\<EnLvlOccpnc\>" <> ToString[n] <> "\<_\>" <> 
              ToString[
                e] <> "\<.dat\>", \[IndentingNewLine]\t\t\t\t\t\t\tA, \
"\<Table\>"];\[IndentingNewLine]\t\t\t\t]\)], "Input"],

Cell[BoxData[
    \(NE[4, 4]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(!! EnLvlOccpnc1_1.dat\)\)], "Input"],

Cell["\<\
3    16      8     8     0   0
4    32      8     12    0   0
5    52      16    12    0   0
6    80      16    16    0   0
7    120     16    20    0   0
8    164     24    20    0   0
9    208     24    24    0   0
10   260     32    24    0   0
11   324     32    28    0   0
12   384     32    32    0   0
13   468     40    32    0   0
14   540     40    36    0   0
15   632     48    36    0   0
16   724     48    40    0   0
17   816     56    40    0   0
18   920     56    44    0   0
19   1020    56    48    0   0
20   1152    64    48    0   0
24   1672    72    60    0   0
28   2316    88    68    0   0
32   3048    104   76    0   0
36   3860    112   88    0   0
40   4800    128   96    0   0
44   5844    144   104   0   0
48   6964    152   116   0   0
52   8200    168   124   0   0
56   9540    184   132   0   0
60   10968   192   144   0   0
64   12532   208   152   0   0\
\>", "Print"]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{760, 829},
WindowMargins->{{Automatic, 1}, {Automatic, 23}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "afs", "nd.edu", \
"user19", "swong1", "Private", "Mathematica", "Discrete_space3D"}, \
"circle.nb.ps", CharacterEncoding -> "ISO8859-1"],
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 6668, 128, 1509, "Input"],
Cell[8388, 179, 1202, 21, 283, "Input"],
Cell[9593, 202, 43, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[9661, 207, 61, 1, 27, "Input"],
Cell[9725, 210, 68, 1, 27, "Output"]
}, Open  ]],
Cell[9808, 214, 983, 18, 219, "Input"],
Cell[10794, 234, 41, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[10860, 239, 58, 1, 27, "Input"],
Cell[10921, 242, 923, 30, 443, "Print"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

